# DataExchange
TKXSBase
StepData

# StepData_FreeFormEntity Class Reference

A Free Form Entity allows to record any kind of STEP
parameters, in any way of typing
It is implemented with an array of fields
A Complex entity can be defined, as a chain of FreeFormEntity
(see Next and As)
.

`#include <StepData_FreeFormEntity.hxx>`

## Public Member Functions

Standard_EXPORT | StepData_FreeFormEntity ()
| Creates a FreeFormEntity, with no field, no type .
Standard_EXPORT void | SetStepType (const Standard_CString typenam)
| Sets the type of an entity For a complex one, the type of this member .
Standard_EXPORT Standard_CString | StepType () const
| Returns the recorded StepType For a complex one, the type of this member .
Standard_EXPORT void | SetNext (const Handle(StepData_FreeFormEntity)&next, const Standard_Boolean last=Standard_True)
| Sets a next member, in order to define or complete a Complex entity If <last> is True (D), this next will be set as last of list Else, it is inserted just as next of <me> If <next> is Null, Next is cleared .
Standard_EXPORT Handle_StepData_FreeFormEntity | Next () const
| Returns the next member of a Complex entity (remark : the last member has none) .
Standard_EXPORT Standard_Boolean | IsComplex () const
| Returns True if a FreeFormEntity is Complex (i.e. has Next) .
Standard_EXPORT Handle_StepData_FreeFormEntity | Typed (const Standard_CString typenam) const
| Returns the member of a FreeFormEntity of which the type name is given (exact match, no sub-type) .
Standard_EXPORT Handle_TColStd_HSequenceOfAsciiString | TypeList () const
| Returns the list of types (one type for a simple entity), as is (non reordered) .
Standard_EXPORT void | SetNbFields (const Standard_Integer nb)
| Sets a count of Fields, from scratch .
Standard_EXPORT Standard_Integer | NbFields () const
| Returns the count of fields .
Standard_EXPORT const StepData_Field & | Field (const Standard_Integer num) const
| Returns a field from its rank, for read-only use .
Standard_EXPORT StepData_Field & | CField (const Standard_Integer num)
| Returns a field from its rank, in order to modify it .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Static Public Member Functions

static Standard_EXPORT Standard_Boolean | Reorder (Handle(StepData_FreeFormEntity)&ent)
| Reorders a Complex entity if required, i.e. if member types are not in alphabetic order Returns False if nothing done (order was OK or simple entity), True plus modified <ent> if <ent> has been reordered .

## Private Attributes

TCollection_AsciiString | thetype
Handle_StepData_HArray1OfField | thefields
Handle_StepData_FreeFormEntity | thenext

## Constructor & Destructor Documentation

Standard_EXPORT StepData_FreeFormEntity::StepData_FreeFormEntity | ( |  | ) |

## Member Function Documentation

Standard_EXPORT StepData_Field& StepData_FreeFormEntity::CField | ( | const Standard_Integer | num | ) |

Standard_EXPORT const StepData_Field& StepData_FreeFormEntity::Field | ( | const Standard_Integer | num | ) | const

Standard_EXPORT const StepData_FreeFormEntity::Handle | ( | Standard_Type |  | ) | const

Standard_EXPORT Standard_Boolean StepData_FreeFormEntity::IsComplex | ( |  | ) | const

Standard_EXPORT Standard_Integer StepData_FreeFormEntity::NbFields | ( |  | ) | const

Standard_EXPORT Handle_StepData_FreeFormEntity StepData_FreeFormEntity::Next | ( |  | ) | const

static Standard_EXPORT Standard_Boolean StepData_FreeFormEntity::Reorder | ( | Handle(StepData_FreeFormEntity)& | ent | ) | `[static]`

Standard_EXPORT void StepData_FreeFormEntity::SetNbFields | ( | const Standard_Integer | nb | ) |

Standard_EXPORT void StepData_FreeFormEntity::SetNext | ( | const Handle(StepData_FreeFormEntity)& | next,
|  | const Standard_Boolean | last = `Standard_True`
| ) |

Standard_EXPORT void StepData_FreeFormEntity::SetStepType | ( | const Standard_CString | typenam | ) |

Standard_EXPORT Standard_CString StepData_FreeFormEntity::StepType | ( |  | ) | const

Standard_EXPORT Handle_StepData_FreeFormEntity StepData_FreeFormEntity::Typed | ( | const Standard_CString | typenam | ) | const

Standard_EXPORT Handle_TColStd_HSequenceOfAsciiString StepData_FreeFormEntity::TypeList | ( |  | ) | const

## Field Documentation

Handle_StepData_HArray1OfField StepData_FreeFormEntity::thefields `[private]`

Handle_StepData_FreeFormEntity StepData_FreeFormEntity::thenext `[private]`

TCollection_AsciiString StepData_FreeFormEntity::thetype `[private]`

The documentation for this class was generated from the following file:

- StepData_FreeFormEntity.hxx